Subject: Re: Licensing Terms
From: DJ Delorie <[email-masked]>

07 Nov 1998 16:57:03 -0500
Message-ID: <[email-masked]>
References: <[email-masked]> <[email-masked]>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 7bit
X-Mailer: Mozilla 3.0 (X11; I; IRIX 5.3 IP22)

Stephen Vance wrote:
> My understanding is that you are allowed to point to the sources.  You
> merely need to make them available.

For the GNU GPL version 2, RMS's interpretation is that the sources
have to be made available from the same FTP site (if you use FTP),
because you don't have control over what's available at our site,
and we may remove the particular sources your dll is built with,
and you would unknowingly become in voilation of the GPL.  You
may also not be able to get to our site, due to network problems,
corporate site blocking firewalls, weird politics, etc.  Basically,
the only way to ensure that people who can get the DLL can also
get the sources is to put them on the same machine.

In GPL 3, this may be relaxed a bit, allowing you to use sources
on the Internet to satisfy non-internet binary distributions,
but you would still need to be in control of those sources,
so that you can ensure that they remain available for the required
time (three years).

Of course, Cygnus may choose to interpret it differently, since we're
the copyright owners.  However, if it (for some reason) makes it to
a court trial, it's still *your* responsibility to provide
the sources, not ours, if *you* are the one distributing the DLL.

> However, you must also include pointers to *your own* sources.  In effect,
> linking against the Cygwin DLL "taints" your code.  This is the essential
> distinction between the GPL and the Library GPL (LGPL) in my understanding.

In the case of DLLs, the LGPL would be ideal, because you could 
just ship the sources to the one DLL and leave your application
as a pure binary (rather than objects, as the LGPL requires
for static libraries).  However, using the LGPL would also remove
any influence cygwin has to coerce people to write free software
(I don't know if this is the real reason for GPL vs LGPL, but it
is *one* reason I can think of) and/or purchase a commercial
license from Cygnus (if you think this is selfish, remember
that my paycheck depends on those licenses).

The cygwin license predates my involvement, so I don't know what
the original motivations were.